const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');

const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class ApplicationsDBApi {
  static async create(data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const applications = await db.applications.create(
      {
        id: data.id || undefined,

        submitted_at: data.submitted_at || null,
        status: data.status || null,
        importHash: data.importHash || null,
        createdById: currentUser.id,
        updatedById: currentUser.id,
      },
      { transaction },
    );

    await applications.setCandidate(data.candidate || null, {
      transaction,
    });

    await applications.setRequisition(data.requisition || null, {
      transaction,
    });

    await applications.setOrganizations(data.organizations || null, {
      transaction,
    });

    return applications;
  }

  static async bulkImport(data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    // Prepare data - wrapping individual data transformations in a map() method
    const applicationsData = data.map((item, index) => ({
      id: item.id || undefined,

      submitted_at: item.submitted_at || null,
      status: item.status || null,
      importHash: item.importHash || null,
      createdById: currentUser.id,
      updatedById: currentUser.id,
      createdAt: new Date(Date.now() + index * 1000),
    }));

    // Bulk create items
    const applications = await db.applications.bulkCreate(applicationsData, {
      transaction,
    });

    // For each item created, replace relation files

    return applications;
  }

  static async update(id, data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;
    const globalAccess = currentUser.app_role?.globalAccess;

    const applications = await db.applications.findByPk(
      id,
      {},
      { transaction },
    );

    const updatePayload = {};

    if (data.submitted_at !== undefined)
      updatePayload.submitted_at = data.submitted_at;

    if (data.status !== undefined) updatePayload.status = data.status;

    updatePayload.updatedById = currentUser.id;

    await applications.update(updatePayload, { transaction });

    if (data.candidate !== undefined) {
      await applications.setCandidate(
        data.candidate,

        { transaction },
      );
    }

    if (data.requisition !== undefined) {
      await applications.setRequisition(
        data.requisition,

        { transaction },
      );
    }

    if (data.organizations !== undefined) {
      await applications.setOrganizations(
        data.organizations,

        { transaction },
      );
    }

    return applications;
  }

  static async deleteByIds(ids, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const applications = await db.applications.findAll({
      where: {
        id: {
          [Op.in]: ids,
        },
      },
      transaction,
    });

    await db.sequelize.transaction(async (transaction) => {
      for (const record of applications) {
        await record.update({ deletedBy: currentUser.id }, { transaction });
      }
      for (const record of applications) {
        await record.destroy({ transaction });
      }
    });

    return applications;
  }

  static async remove(id, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const applications = await db.applications.findByPk(id, options);

    await applications.update(
      {
        deletedBy: currentUser.id,
      },
      {
        transaction,
      },
    );

    await applications.destroy({
      transaction,
    });

    return applications;
  }

  static async findBy(where, options) {
    const transaction = (options && options.transaction) || undefined;

    const applications = await db.applications.findOne(
      { where },
      { transaction },
    );

    if (!applications) {
      return applications;
    }

    const output = applications.get({ plain: true });

    output.interviews_application =
      await applications.getInterviews_application({
        transaction,
      });

    output.offers_application = await applications.getOffers_application({
      transaction,
    });

    output.candidate = await applications.getCandidate({
      transaction,
    });

    output.requisition = await applications.getRequisition({
      transaction,
    });

    output.organizations = await applications.getOrganizations({
      transaction,
    });

    return output;
  }

  static async findAll(filter, globalAccess, options) {
    const limit = filter.limit || 0;
    let offset = 0;
    let where = {};
    const currentPage = +filter.page;

    const user = (options && options.currentUser) || null;
    const userOrganizations = (user && user.organizations?.id) || null;

    if (userOrganizations) {
      if (options?.currentUser?.organizationsId) {
        where.organizationsId = options.currentUser.organizationsId;
      }
    }

    offset = currentPage * limit;

    const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [
      {
        model: db.candidates,
        as: 'candidate',

        where: filter.candidate
          ? {
              [Op.or]: [
                {
                  id: {
                    [Op.in]: filter.candidate
                      .split('|')
                      .map((term) => Utils.uuid(term)),
                  },
                },
                {
                  name: {
                    [Op.or]: filter.candidate
                      .split('|')
                      .map((term) => ({ [Op.iLike]: `%${term}%` })),
                  },
                },
              ],
            }
          : {},
      },

      {
        model: db.job_requisitions,
        as: 'requisition',

        where: filter.requisition
          ? {
              [Op.or]: [
                {
                  id: {
                    [Op.in]: filter.requisition
                      .split('|')
                      .map((term) => Utils.uuid(term)),
                  },
                },
                {
                  title: {
                    [Op.or]: filter.requisition
                      .split('|')
                      .map((term) => ({ [Op.iLike]: `%${term}%` })),
                  },
                },
              ],
            }
          : {},
      },

      {
        model: db.organizations,
        as: 'organizations',
      },
    ];

    if (filter) {
      if (filter.id) {
        where = {
          ...where,
          ['id']: Utils.uuid(filter.id),
        };
      }

      if (filter.submitted_atRange) {
        const [start, end] = filter.submitted_atRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            submitted_at: {
              ...where.submitted_at,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            submitted_at: {
              ...where.submitted_at,
              [Op.lte]: end,
            },
          };
        }
      }

      if (filter.active !== undefined) {
        where = {
          ...where,
          active: filter.active === true || filter.active === 'true',
        };
      }

      if (filter.status) {
        where = {
          ...where,
          status: filter.status,
        };
      }

      if (filter.organizations) {
        const listItems = filter.organizations.split('|').map((item) => {
          return Utils.uuid(item);
        });

        where = {
          ...where,
          organizationsId: { [Op.or]: listItems },
        };
      }

      if (filter.createdAtRange) {
        const [start, end] = filter.createdAtRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            ['createdAt']: {
              ...where.createdAt,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            ['createdAt']: {
              ...where.createdAt,
              [Op.lte]: end,
            },
          };
        }
      }
    }

    if (globalAccess) {
      delete where.organizationsId;
    }

    const queryOptions = {
      where,
      include,
      distinct: true,
      order:
        filter.field && filter.sort
          ? [[filter.field, filter.sort]]
          : [['createdAt', 'desc']],
      transaction: options?.transaction,
      logging: console.log,
    };

    if (!options?.countOnly) {
      queryOptions.limit = limit ? Number(limit) : undefined;
      queryOptions.offset = offset ? Number(offset) : undefined;
    }

    try {
      const { rows, count } = await db.applications.findAndCountAll(
        queryOptions,
      );

      return {
        rows: options?.countOnly ? [] : rows,
        count: count,
      };
    } catch (error) {
      console.error('Error executing query:', error);
      throw error;
    }
  }

  static async findAllAutocomplete(
    query,
    limit,
    offset,
    globalAccess,
    organizationId,
  ) {
    let where = {};

    if (!globalAccess && organizationId) {
      where.organizationId = organizationId;
    }

    if (query) {
      where = {
        [Op.or]: [
          { ['id']: Utils.uuid(query) },
          Utils.ilike('applications', 'status', query),
        ],
      };
    }

    const records = await db.applications.findAll({
      attributes: ['id', 'status'],
      where,
      limit: limit ? Number(limit) : undefined,
      offset: offset ? Number(offset) : undefined,
      orderBy: [['status', 'ASC']],
    });

    return records.map((record) => ({
      id: record.id,
      label: record.status,
    }));
  }
};
